<?php
/******************************************************************************
* TPdlmanager.php                                                                   *
*******************************************************************************
* TP: Tiny Portal for SMF                                                  *
* Software Version:           SMF 0.8                                       *
* Software by:                Bloc (http://www.tinyportal.net) *
* Copyright 2005 by:     Bloc (bloc@tinyportal.net)         *
* Support, News, Updates at:  http://www.tinyportal.net                   *
*******************************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');


function TPdlmanager_init()
{
	global $context, $settings;

	// get subaction
	if(isset($context['TPortal']['dlsub'])){

		// see if its admin section
		if(substr($context['TPortal']['dlsub'],0,5)=='admin' || $context['TPortal']['dlsub']=='submission')
			TPortalDLAdmin();
		else
			TPortalDLManager();
	}
}

// TinyPortal DLmanager
function TPortalDLManager()
{
	global $txt, $scripturl, $db_prefix, $ID_MEMBER, $user_info, $sourcedir, $boarddir, $boardurl;
	global $modSettings, $context, $settings;

   // assume its the frontpage initially
   $context['TPortal']['dlaction']='main';

   $tp_prefix=$settings['tp_prefix'];

	// check that you can upload at all
	if(allowedTo('tp_dlupload'))
	    $context['TPortal']['can_upload']=true;
	else
	    $context['TPortal']['can_upload']=false;


	// any uploads being sent?
	$context['TPortal']['uploads']=array();
	if(isset($_FILES['tp-dluploadfile']['tmp_name']))
	{
		// check that nothing happended
		if(!file_exists($_FILES['tp-dluploadfile']['tmp_name']) || !is_uploaded_file($_FILES['tp-dluploadfile']['tmp_name']))
			fatal_error($txt['tp-dluploadfailure']);

		// first, can we upload at all?
		if(!$context['TPortal']['can_upload']){
			unlink($_FILES['tp-dluploadfile']['tmp_name']);
			fatal_error($txt['tp-dluploadnotallowed']);
		}
		// a file it is
		$title= isset($_POST['tp-dluploadtitle']) ? strip_tags($_POST['tp-dluploadtitle']) : '-no title-';
		if(empty($title))
			$title='-no title-';
		$text= isset($_POST['tp-dluploadtext']) ? $_POST['tp-dluploadtext'] : '';
		$category = isset($_POST['tp-dluploadcat']) ? $_POST['tp-dluploadcat'] : '0';
		$shot = isset($_POST['tp_dluploadpic']) ? $_POST['tp_dluploadpic'] : '';
		$icon= isset($_POST['tp_dluploadicon']) ? $boardurl.'/tp-downloads/icons/'.$_POST['tp_dluploadicon'] : '';

		// process the file
		$filename=$_FILES['tp-dluploadfile']['name'];

		$name = strtr($filename, '', 'SZszYAAAAAACEEEEIIIINOOOOOOUUUUYaaaaaaceeeeiiiinoooooouuuuyy');
		$name = strtr($name, array('' => 'TH', '' => 'th', '' => 'DH', '' => 'dh', '' => 'ss', '' => 'OE', '' => 'oe', '' => 'AE', '' => 'ae', '' => 'u'));
		$name = preg_replace(array('/\s/', '/[^\w_\.\-]/'), array('_', ''), $name);
		$status = 'normal';

		// check the size
		$dlfilesize = filesize($_FILES['tp-dluploadfile']['tmp_name']);
		if($dlfilesize>(1000*$context['TPortal']['dl_max_upload_size'])){
			$status='maxsize';
			unlink($_FILES['tp-dluploadfile']['tmp_name']);
			$error = $txt['tp-dlmaxerror'].' '.($context['TPortal']['dl_max_upload_size']).' Kb<br /><br />'.$txt['tp-dlmaxerror2'].': '. ceil($dlfilesize/1000) .' Kb';
			fatal_error($error);
		}

		// check the extension
		$allowed=explode(',',$context['TPortal']['dl_allowed_types']);
		$dlext=substr(strstr($name, '.'),1);
		if(!in_array($dlext, $allowed)){
			$status='wrongtype';
			unlink($_FILES['tp_dluploadfile']['tmp_name']);
			$error = $txt['tp-dlexterror'].':<b> <br />'.$context['TPortal']['dl_allowed_types'].'</b><br /><br />'.$txt['tp-dlexterror2'].': <b>'.$dlext.'</b>';
			fatal_error($error);
		}

		// ok, go ahead
		if($status=='normal'){

			// check that no other file exists with same name
			if(file_exists($boarddir.'/tp-downloads/'.$name))
				$name= mktime().$name;

			$success=move_uploaded_file($_FILES['tp-dluploadfile']['tmp_name'],$boarddir.'/tp-downloads/'.$name);

			// insert it into the database
			$now=time();

			// if all uploads needs to be approved: set category to -category , but not for dl admins
			if($context['TPortal']['dl_approve']=='1' && !allowedTo('tp_dlmanager')){
					$category = $category-$category-$category;
			}

			db_query("INSERT INTO {$tp_prefix}dlmanager
						(name, description, icon, category, type, downloads, views, file, created, last_access, filesize, parent, access, link,authorID,screenshot )
			VALUES ('$title', '$text', '$icon' , $category, 'dlitem', 0, 1, '$name', $now, $now, $dlfilesize, 0, '', '', $ID_MEMBER, '$shot')", __FILE__, __LINE__);
			$newitem = mysql_insert_id();
			// put this into submissions - id and type
			if($category < 0){
				db_query("INSERT INTO {$tp_prefix}variables (value1,value2,value3,type,value4,value5 ) VALUES ('$title', '$now', '','dl_not_approved', '' , $newitem)", __FILE__, __LINE__);
				redirectexit('action=tpmod;sub=dlsubmitsuccess');
			}
			else
				redirectexit('action=tpmod;dl=item'.$newitem);
		 }
	}
// ***************************************************
		// ok, on with the show :)

	//first : fetch all allowed categories
	$context['TPortal']['uploadcats'] = array();
	$request = db_query("SELECT id, parent, name, access FROM {$tp_prefix}dlmanager WHERE type = 'dlcat'", __FILE__, __LINE__);
	if(mysql_num_rows($request)>0){
		while ($row = mysql_fetch_assoc($request))
		{
			$show = get_perm($row['access']);
			if($show)
				$context['TPortal']['uploadcats'][$row['id']] = array(
					'id' => $row['id'],
					'name' => $row['name'],
					'parent' => $row['parent'],
					);
		}
		mysql_free_result($request);
	}
	// showing a category, or even a single item?
	$context['TPortal']['dlaction'] = '';
	if(isset($context['TPortal']['dlsub']))
	{
			// a category?
		if(substr($context['TPortal']['dlsub'],0,3)=='cat'){
				$context['TPortal']['dlcat']=substr($context['TPortal']['dlsub'],3);
				$context['TPortal']['dlaction']='cat';
		}
		elseif(substr($context['TPortal']['dlsub'],0,4)=='item'){
				$context['TPortal']['dlitem']=substr($context['TPortal']['dlsub'],4);
				$item=$context['TPortal']['dlitem'];
				$context['TPortal']['item']=$item;
				$context['TPortal']['dlaction']='item';
				$request = db_query("SELECT * FROM {$tp_prefix}dlmanager WHERE id = $item AND type = 'dlitem' LIMIT 1", __FILE__, __LINE__);
			if(mysql_num_rows($request)>0){
					$row=mysql_fetch_assoc($request);
					$context['TPortal']['dlcat'] = $row['category'];
					mysql_free_result($request);
			}
		}
		elseif($context['TPortal']['dlsub']=='stats'){
			$context['TPortal']['dlaction']='stats';
			$context['TPortal']['dlitem']='';
		}
		elseif($context['TPortal']['dlsub']=='submission'){
			$context['TPortal']['dlaction']='submission';
			$context['TPortal']['dlitem']='';
		}
		elseif(substr($context['TPortal']['dlsub'],0,3)=='get'){
			$context['TPortal']['dlitem']=substr($context['TPortal']['dlsub'],3);
			$context['TPortal']['dlaction']='get';
		}
		elseif(substr($context['TPortal']['dlsub'],0,6)=='upload'){
			$context['TPortal']['dlitem']=substr($context['TPortal']['dlsub'],6);
			$context['TPortal']['dlaction']='upload';

			// check your permission for uploading
			isAllowedTo('tp_dlupload');

			// fetch icons, just read the directory
			$context['TPortal']['dlicons'] = array();
			if ($handle = opendir($boarddir.'/tp-downloads/icons')) {
				while (false !== ($file = readdir($handle))) {
					if($file!= '.' && $file!='..' && $file!='.htaccess')
						$context['TPortal']['dlicons'][] = $file;
				}
				closedir($handle);
				sort($context['TPortal']['dlicons']);
			}
		}
	}
	// add to the linktree
	TPadd_linktree($scripturl.'?action=tpmod;dl=0', $txt['tp-downloads']);

	// set the title
	$context['page_title']=$txt['tp-downloads'];
	$context['TPortal']['dl_title'] = $txt['tp-mainpage'];

	// load the dlmanager frontpage
	if($context['TPortal']['dlaction']=='')
	{
		$context['TPortal']['dlcats'] = array();
		$context['TPortal']['dlcatchilds'] = array();

/* start add by Feline */
    // this is a little bit tricky DB-Query :-)
    // that will get summary of files in all parent and childs with any deept
    // without any other info on number of files in then categories
		$request = db_query("
		SELECT
		a.access AS access,
		a.icon AS icon,
		a.description AS description,
		a.name AS name,
		a.id AS id,
	  	a.parent AS parent,
	  	if (a.id = b.category, count(*), 0) AS files,
	  	b.category AS subchild
		FROM {$tp_prefix}dlmanager AS a
		LEFT JOIN {$tp_prefix}dlmanager AS b
	  		ON a.id = b.category
		WHERE a.type = 'dlcat'
	  	GROUP BY a.id
	  	ORDER BY a.downloads ASC", __FILE__, __LINE__);

		if(mysql_num_rows($request)>0)
		{
			while ($row = mysql_fetch_assoc($request))
			{
				$show = get_perm($row['access']);
				if($show && $row['parent']==0){
					$context['TPortal']['dlcats'][] = array(
							'id' => $row['id'],
							'name' => $row['name'],
							'parent' => $row['parent'],
							'description' => $row['description'],
							'access' => $row['access'],
							'icon' => $row['icon'],
							'href' => $scripturl.'?action=tpmod;dl=cat'.$row['id'],
							'files' => $row['files'],
							);
				}
				elseif($show && $row['parent']>0){
						$context['TPortal']['dlcatchilds'][] = array(
							'id' => $row['id'],
							'name' => $row['name'],
							'parent' => $row['parent'],
							'href' => $scripturl.'?action=tpmod;dl=cat'.$row['id'],
							);
				}
			}
			mysql_free_result($request);
		}
	}
	// load a category
	elseif($context['TPortal']['dlaction']=='cat')
	{
		//fetch all  categories and its childs
		$context['TPortal']['dlcats'] = array();
		$context['TPortal']['dlcatchilds'] = array();
		$parents=array();

		$currentcat = $context['TPortal']['dlcat'];
		// do we have access then?
		$request = db_query("SELECT parent,access,name FROM {$tp_prefix}dlmanager WHERE id = $currentcat", __FILE__, __LINE__);
		if(mysql_num_rows($request)>0)
		{
			while ($row = mysql_fetch_assoc($request))
			{
				$currentname=$row['name'];
				$catparent = $row['parent'];
				if(!get_perm($row['access']))
	               fatal_error($txt['tp-notallowed']);
	        }
	        mysql_free_result($request);
	    }

/* start add by Feline */
    // this is a little bit tricky DB-Query :-)
    // that will get summary of files in all parent and childs with any deept
    // without any other info on number of files in then categories
		$request = db_query("
		SELECT
		a.access AS access,
		a.icon AS icon,
		a.description AS description,
		a.name AS name,
		a.id AS id,
	  	a.parent AS parent,
	  	if (a.id = b.category, count(*), 0) AS files,
	  	b.category AS subchild
		FROM {$tp_prefix}dlmanager AS a
		LEFT JOIN {$tp_prefix}dlmanager AS b
	  		ON a.id = b.category
		WHERE a.type = 'dlcat'
		AND a.parent=$currentcat
	  	GROUP BY a.id
	  	ORDER BY a.downloads ASC", __FILE__, __LINE__);

		if(mysql_num_rows($request)>0)
		{
			while ($row = mysql_fetch_assoc($request))
			{
				$show = get_perm($row['access']);
				if($show && $row['parent']==$currentcat){
					$context['TPortal']['dlcats'][] = array(
							'id' => $row['id'],
							'name' => $row['name'],
							'parent' => $row['parent'],
							'description' => $row['description'],
							'access' => $row['access'],
							'icon' => $row['icon'],
							'href' => $scripturl.'?action=tpmod;dl=cat'.$row['id'],
							'files' => $row['files'],
							);
				}
				elseif($show && $row['parent']!=$currentcat){
						$context['TPortal']['dlcatchilds'][] = array(
							'id' => $row['id'],
							'name' => $row['name'],
							'parent' => $row['parent'],
							'href' => $scripturl.'?action=tpmod;dl=cat'.$row['id'],
							);
				}
			}
			mysql_free_result($request);
		}

		// get any items in the category
			$context['TPortal']['dlitem'] = array();
			$start=0;
			if(isset($_GET['tpstart']))
				$start=$_GET['tpstart'];

			// get total count
			$request = db_query("SELECT COUNT(*) FROM {$tp_prefix}dlmanager WHERE type = 'dlitem' AND category=$currentcat", __FILE__, __LINE__);
			$row=mysql_fetch_row($request);
			$rows2=$row[0];

			$request = db_query("SELECT * FROM {$tp_prefix}dlmanager WHERE type = 'dlitem' AND category=$currentcat LIMIT $start,10", __FILE__, __LINE__);

			if(mysql_num_rows($request)>0)
			{
				while ($row = mysql_fetch_assoc($request))
				{
					$context['TPortal']['dlitem'][] = array(
						'id' => $row['id'],
						'name' => $row['name'],
						'description' => $row['description'],
						'category' => $row['category'],
						'file' => $row['file'],
						'href' => $scripturl.'?action=tpmod;dl=item'.$row['id'],
						'downloads' => $row['downloads'],
						'views' => $row['views'],
						'link' => $row['link'],
						'date_last' => $row['last_access'],
						'author' => '',
						'authorID' => $row['authorID'],
						'screenshot' => $row['screenshot'],
						'sshot' => $row['screenshot'],
						'icon' => $row['icon'],
						'date' => $row['created']
					);
					$author = $row['authorID'];
					$views = $row['views'];
					$itemname = $row['name'];
					$itemid = $row['id'];
				}
				mysql_free_result($request);
			}
			if(isset($context['TPortal']['mystart']))
				$mystart=$context['TPortal']['mystart'];

			// construct a pageindex
			$context['TPortal']['pageindex'] = TPageIndex($scripturl . '?action=tpmod;dl=cat'.$currentcat, $mystart , $rows2, 10, true);

		// check backwards for parents
		while($catparent>0 ){
			$context['TPortal']['parents'][$catparent] = array(
				'id' => $catparent,
				'name' => $context['TPortal']['uploadcats'][$catparent]['name'],
				'parent' => $context['TPortal']['uploadcats'][$catparent]['parent']
				);
			$parents[] = array(
				'id' => $catparent,
				'name' => $context['TPortal']['uploadcats'][$catparent]['name'],
				'parent' => $context['TPortal']['uploadcats'][$catparent]['parent']
				);
			$catparent = $context['TPortal']['uploadcats'][$catparent]['parent'];
		}

		// make the linktree
		if(isset($parents)){
			$parts=array_reverse($parents,TRUE);
			// add to the linktree
			foreach($parts as $parent){
				TPadd_linktree($scripturl.'?action=tpmod;dl=cat'.$parent['id'] , $parent['name']);
			}
		}
		// add to the linktree
		TPadd_linktree($scripturl.'?action=tpmod;dl=cat'.$currentcat , $currentname);

	}
	elseif($context['TPortal']['dlaction']=='item')
	{
		//fetch the category
		$cat = $context['TPortal']['dlcat'];
		$context['TPortal']['dlcats'] = array();
		$catname='' ; $catdesc='';
		$parents = array();

		$request = db_query("SELECT id,name,parent,icon,access FROM {$tp_prefix}dlmanager WHERE id = $cat AND type = 'dlcat' LIMIT 1", __FILE__, __LINE__);
		if(mysql_num_rows($request)>0){
			while ($row = mysql_fetch_assoc($request))
			{
				$catname= $row['name'];
				$catparent = $row['parent'];
				$parents[] = array(
					'id' => $row['id'],
					'name' => $row['name'],
					'parent' => $row['parent'],
					);

				// check if you are allowed in here
				$show = get_perm($row['access']);
				if(!$show)
					fatal_error($txt['tp-notallowed']);
			}
			mysql_free_result($request);
		}

		// set the title
		$context['TPortal']['dl_title'] = $catname;

		// check to see if its child
		while($catparent>0 ){
			$parents[$catparent] = array(
				'id' => $catparent,
				'name' => $context['TPortal']['uploadcats'][$catparent]['name'],
				'parent' => $context['TPortal']['uploadcats'][$catparent]['parent']
				);
			$catparent = $context['TPortal']['uploadcats'][$catparent]['parent'];
		}

		$context['TPortal']['parents'] = $parents;

		// make the linktree
		if(isset($parents)){
			$parts=array_reverse($parents,TRUE);
			// add to the linktree
			foreach($parts as $parent){
				TPadd_linktree($scripturl.'?action=tpmod;dl=cat'.$parent['id'] , $parent['name']);
			}
		}
		// add to the linktree
		TPadd_linktree($scripturl.'?action=tpmod;dl=cat'.$cat , $catname);

		// fetch the item data
		$item =	$context['TPortal']['item']=$item;
		$context['TPortal']['dlitem'] = array();
		$request = db_query("SELECT dl.* , m.realName
							FROM {$tp_prefix}dlmanager AS dl, {$db_prefix}members AS m
							WHERE dl.type = 'dlitem'
							AND dl.id=$item
							AND dl.authorID=m.ID_MEMBER
							LIMIT 1", __FILE__, __LINE__);
		if(mysql_num_rows($request)>0){
			$rows=mysql_num_rows($request);
			while ($row = mysql_fetch_assoc($request))
				{
					$context['TPortal']['dlitem'][] = array(
						'id' => $row['id'],
						'name' => $row['name'],
						'description' => $row['description'],
						'category' => $row['category'],
						'file' => $row['file'],
						'href' => $scripturl.'?action=tpmod;dl=get'.$row['id'],
						'downloads' => $row['downloads'],
						'views' => $row['views'],
						'link' => $row['link'],
						'date_last' => $row['last_access'],
						'author' => $row['realName'],
						'authorID' => $row['authorID'],
						'screenshot' => $row['screenshot'],
						'sshot' => $row['screenshot'],
						'icon' => $row['icon'],
						'created' => $row['created']
					);
					$author = $row['authorID'];
					$views = $row['views'];
					$itemname = $row['name'];
					$itemid = $row['id'];
				}
				mysql_free_result($request);
				// update the views!
				$views++;
				db_query("UPDATE {$tp_prefix}dlmanager SET views=$views WHERE id=$itemid", __FILE__, __LINE__);
		}
	}
	elseif($context['TPortal']['dlaction']=='get'){
			TPdownload();
	}
	elseif($context['TPortal']['dlaction']=='stats'){
			TPdlstats();
	}
	loadtemplate('TPdlmanager');
}

// show some stats
function TPdlstats()
{
	global $txt, $scripturl, $db_prefix, $modSettings, $context, $settings , $boarddir;

	$tp_prefix=$settings['tp_prefix'];

	$context['TPortal']['dl_scats']=array();
	$context['TPortal']['dl_sitems']=array();
	$context['TPortal']['dl_scount']=array();
	// count items in each category
	$request = db_query("SELECT category FROM {$tp_prefix}dlmanager WHERE type = 'dlitem'", __FILE__, __LINE__);
	if(mysql_num_rows($request)>0){
		while($row=mysql_fetch_assoc($request)){
			if($row['category']>0){
				if(isset($context['TPortal']['dl_scount'][$row['category']]))
					$context['TPortal']['dl_scount'][$row['category']]++;
				else
					$context['TPortal']['dl_scount'][$row['category']]=1;
			}
		}
		mysql_free_result($request);
	}


	//first : fetch all allowed categories
	$context['TPortal']['uploadcats'] = array();
	$request = db_query("SELECT id, parent, name, access FROM {$tp_prefix}dlmanager WHERE type = 'dlcat'", __FILE__, __LINE__);
	if(mysql_num_rows($request)>0){
		while ($row = mysql_fetch_assoc($request))
		{
			$show = get_perm($row['access']);
			if($show)
				$context['TPortal']['uploadcats'][$row['id']] = array(
					'id' => $row['id'],
					'name' => $row['name'],
					'parent' => $row['parent'],
					);
		}
		mysql_free_result($request);
	}

		// fetch all categories with subcats
		$req = db_query("SELECT * FROM {$tp_prefix}dlmanager WHERE type = 'dlcat'", __FILE__, __LINE__);
	if(mysql_num_rows($req)>0){
		while($brow=mysql_fetch_assoc($req)){
    		if(get_perm($brow['access'])){
				if(isset($context['TPortal']['dl_scount'][$brow['id']]))
					$items=$context['TPortal']['dl_scount'][$brow['id']];
				else
					$items=0;

				$context['TPortal']['topcats'][] = array(
					'items' => $items,
					'link' => '<a href="'.$scripturl.'?action=tpmod;dl=cat'.$brow['id'].'">'.$brow['name'].'</a>',
					);
				// add the category as viewable
				$context['TPortal']['viewcats'][] = $brow['id'];
			}
		}
	mysql_free_result($req);
	// sort it
    usort($context['TPortal']['topcats'], "dlsort");

	}

		// fetch all items
		$request = db_query("SELECT * FROM {$tp_prefix}dlmanager WHERE type = 'dlitem'", __FILE__, __LINE__);
		if(mysql_num_rows($request)>0){
			while($row=mysql_fetch_assoc($request)){
				if(in_array($row['category'],$context['TPortal']['viewcats']))
					$context['TPortal']['topitems'][] = array(
						'size' => $row['filesize'],
						'views' => $row['views'],
						'downloads' => $row['downloads'],
						'link' => '<a href="'.$scripturl.'?action=tpmod;dl=item'.$row['id'].'">'.$row['name'].'</a>',
					);
			}
			mysql_free_result($request);
		// sort it by filesize,views and downloads
		$context['TPortal']['topsize'] = array(); $context['TPortal']['topviews']=array();
		$context['TPortal']['topsize']=$context['TPortal']['topitems'];
    	usort($context['TPortal']['topsize'], "dlsortsize");

		$context['TPortal']['topviews']=$context['TPortal']['topitems'];
    	usort($context['TPortal']['topviews'], "dlsortviews");

    	usort($context['TPortal']['topitems'], "dlsortdownloads");
		}
}

// download a file
function TPdownload()
{
	global $txt, $scripturl, $db_prefix, $modSettings, $context, $settings , $boarddir;

	$tp_prefix=$settings['tp_prefix'];

	$item = $context['TPortal']['dlitem'];
	$request = db_query("SELECT * FROM {$tp_prefix}dlmanager WHERE id=$item LIMIT 1", __FILE__, __LINE__);
	if(mysql_num_rows($request)>0){
		$row = mysql_fetch_assoc($request);
		$myfilename=$row['name'];
		$real_filename=$row['file'];
		$cat=$row['category'];
		$request2 = db_query("SELECT * FROM {$tp_prefix}dlmanager WHERE id=$cat", __FILE__, __LINE__);
		if(mysql_num_rows($request2)>0){
			$row2 = mysql_fetch_assoc($request2);
			$show = get_perm($row2['access']);
			mysql_free_result($request2);
		}
		else{
			$show=false;
		}
		$filename= $boarddir.'/tp-downloads/'.$real_filename;

		mysql_free_result($request);
	}
	else
		$show=false;

	// can we actually download?
	if($show==1){

		db_query("UPDATE LOW_PRIORITY {$tp_prefix}dlmanager	SET downloads = downloads + 1 WHERE id = $item	LIMIT 1", __FILE__, __LINE__);

		ob_end_clean();
		if (!empty($modSettings['enableCompressedOutput']) && @version_compare(PHP_VERSION, '4.2.0') >= 0 && @filesize($filename) <= 4194304)
			@ob_start('ob_gzhandler');
		else
		{
			ob_start();
			header('Content-Encoding: none');
		}
	if (!empty($_SERVER['HTTP_IF_MODIFIED_SINCE']) && strtotime(array_shift(explode(';', $_SERVER['HTTP_IF_MODIFIED_SINCE']))) >= filemtime($filename))
	{
		ob_end_clean();
		header('HTTP/1.1 304 Not Modified');
		exit;
	}

	// Send the attachment headers.
	header('Pragma: ');
	header('Cache-Control: max-age=' . (525600 * 60) . ', private');
	if (!$context['browser']['is_gecko'])
		header('Content-Transfer-Encoding: binary');
	header('Expires: ' . gmdate('D, d M Y H:i:s', time() + 525600 * 60) . ' GMT');
	header('Last-Modified: ' . gmdate('D, d M Y H:i:s', filemtime($filename)) . ' GMT');
	header('Accept-Ranges: bytes');
	header('Set-Cookie:');
	header('Connection: close');

	header('Content-Disposition: attachment; filename="' . $real_filename . '"');
	header('Content-Type: application/octet-stream');

	if (filesize($filename) != 0)
	{
		$size = @getimagesize($filename);
		if (!empty($size) && $size[2] > 0 && $size[2] < 4)
			header('Content-Type: image/' . ($size[2] != 1 ? ($size[2] != 2 ? 'png' : 'jpeg') : 'gif'));
	}

	if (empty($modSettings['enableCompressedOutput']) || filesize($filename) > 4194304)
		header('Content-Length: ' . filesize($filename));

	@set_time_limit(0);

	if (in_array(substr($real_filename, -4), array('.txt', '.css', '.htm', '.php', '.xml')))
	{
		if (strpos($_SERVER['HTTP_USER_AGENT'], 'Windows') !== false)
			$callback = create_function('$buffer', 'return preg_replace(\'~[\r]?\n~\', "\r\n", $buffer);');
		elseif (strpos($_SERVER['HTTP_USER_AGENT'], 'Mac') !== false)
			$callback = create_function('$buffer', 'return preg_replace(\'~[\r]?\n~\', "\r", $buffer);');
		else
			$callback = create_function('$buffer', 'return preg_replace(\'~\r~\', "\r\n", $buffer);');
	}

	// Since we don't do output compression for files this large...
	if (filesize($filename) > 4194304)
	{
		// Forcibly end any output buffering going on.
		if (function_exists('ob_get_level'))
		{
			while (@ob_get_level() > 0)
				@ob_end_clean();
		}
		else
		{
			@ob_end_clean();
			@ob_end_clean();
			@ob_end_clean();
		}

		$fp = fopen($filename, 'rb');
		while (!feof($fp))
		{
			if (isset($callback))
				echo $callback(fread($fp, 8192));
			else
				echo fread($fp, 8192);
			flush();
		}
		fclose($fp);
	}
	// On some of the less-bright hosts, readfile() is disabled.  It's just a faster, more byte safe, version of what's in the if.
	elseif (isset($callback) || @readfile($filename) == null)
		echo isset($callback) ? $callback(file_get_contents($filename)) : file_get_contents($filename);

	obExit(false);
}
else
	fatal_error($txt['tp-notallowed']);

exit();
}

// TinyPortal DLmanager admin
function TPortalDLAdmin()
{

	global $txt, $scripturl, $db_prefix, $ID_MEMBER, $user_info, $sourcedir, $boarddir, $boardurl;
	global $modSettings, $context, $settings , $tp_prefix;

	$tp_prefix=$settings['tp_prefix'];

	// check permission
	isAllowedTo('tp_dlmanager');


	// check for new category
	if(!empty($_POST['newdlsend'])){
		// get the items
		$name=strip_tags($_POST['newdladmin_name']);
		// no html here
		if(empty($value))
			$value='-no title-';

		$text=$_POST['newdladmin_text'];
		$parent=$_POST['newdladmin_parent'];
		$icon=$boardurl.'/tp-downloads/icons/'.$_POST['newdladmin_icon'];
		// special case, the access
    	$dlgrp=array();
           foreach ($_POST as $what => $value) {
                  if($what=='newdladmin_group'){
					if($value!='-2')
                        $dlgrp[]=$value;
                  }
           }
			$access=implode(',',$dlgrp);
			// insert the category
			db_query("INSERT INTO {$tp_prefix}dlmanager (name, description, icon, category, type, downloads, views, file, created, last_access, filesize, parent, access, link,authorID,screenshot ) VALUES ('$name', '$text', '$icon' , 0 , 'dlcat', 0, 0, '', 0, 0, 0, $parent, '$access', '', $ID_MEMBER, '')", __FILE__, __LINE__);
			$newcat=mysql_insert_id();
 			redirectexit('action=tpmod;dl=admineditcat'.$newcat);
	}

	// check for access value
	if(!empty($_POST['dlsend'])){
 		$admgrp=array(); $groupset=false;
 		$dlgrp=array(); $dlset=false;
           foreach ($_POST as $what => $value) {
                  if(substr($what,0,13)=='dladmin_group'){
                        $val=substr($what,13);
						if($val!='-2')
                            $admgrp[]=$val;
                        $groupset=true;
                        $id=$value;
                  }
                  elseif(substr($what,0,8)=='tp_group'){
						if($value!='-2')
                            $dlgrp[]=$value;
                        $dlset=true;
                  }
           }
		  if($groupset){
           	$dlaccess=implode(',',$admgrp);
		  	db_query("UPDATE {$tp_prefix}dlmanager SET access = '$dlaccess' WHERE id=$id", __FILE__, __LINE__);
		  }
		  if($dlset){
           	$dlaccess2=implode(',',$dlgrp);
		  	db_query("UPDATE {$tp_prefix}settings SET value = '$dlaccess2' WHERE name='dl_approve_groups'", __FILE__, __LINE__);
		  }
	$go=0;
	// get all values from forms
	foreach($_POST as $what => $value){
		if(substr($what,0,12)=='dladmin_name'){
			$id=substr($what,12);
			// no html here
			$value=strip_tags($value);
			if(empty($value))
				$value='-no title-';
			db_query("UPDATE {$tp_prefix}dlmanager SET name = '$value' WHERE id=$id", __FILE__, __LINE__);
		}
		elseif(substr($what,0,12)=='dladmin_icon'){
			$id=substr($what,12);
			if($value!=''){
				$val=$boardurl.'/tp-downloads/icons/'.$value;
				db_query("UPDATE {$tp_prefix}dlmanager SET icon = '$val' WHERE id=$id", __FILE__, __LINE__);
			}
		}
		elseif(substr($what,0,12)=='dladmin_text'){
			$id=substr($what,12);
			db_query("UPDATE {$tp_prefix}dlmanager SET description = '$value' WHERE id=$id", __FILE__, __LINE__);
		}
		elseif(substr($what,0,14)=='dladmin_delete'){
			$id=substr($what,14);
				$request = db_query("SELECT * FROM {$tp_prefix}dlmanager WHERE id = $id", __FILE__, __LINE__);
				if(mysql_num_rows($request)>0)
				{
					$row=mysql_fetch_assoc($request);
					if ($row['type'] == 'dlitem')
					{
						$category = $row['category'];
						if ($category > 0)
							db_query("UPDATE {$tp_prefix}dlmanager SET downloads = downloads - 1 WHERE id = $category LIMIT 1", __FILE__, __LINE__);
					}
					mysql_free_result($request);
				}
			db_query("DELETE FROM {$tp_prefix}dlmanager WHERE id=$id", __FILE__, __LINE__);
		}
		elseif(substr($what,0,15)=='dladmin_approve'){
			$id=abs(substr($what,15));
			$request = db_query("SELECT category FROM {$tp_prefix}dlmanager WHERE id = $id", __FILE__, __LINE__);
			if(mysql_num_rows($request)>0)
			{
				$row=mysql_fetch_row($request);
				$newcat = abs($row[0]);
				db_query("UPDATE {$tp_prefix}dlmanager SET category=$newcat WHERE id = $id", __FILE__, __LINE__);
				db_query("DELETE FROM {$tp_prefix}variables WHERE type = 'dl_not_approved' AND value5 = $id", __FILE__, __LINE__);
				mysql_free_result($request);
			}
		}
		elseif(substr($what,0,16)=='dladmin_category'){
			$id=substr($what,16);
			// update, but not on negative values :)
			if($value>0)
				db_query("UPDATE {$tp_prefix}dlmanager SET category = $value WHERE id=$id", __FILE__, __LINE__);
		}
		elseif(substr($what,0,14)=='dladmin_parent'){
			$id=substr($what,14);
			db_query("UPDATE {$tp_prefix}dlmanager SET parent = $value WHERE id=$id", __FILE__, __LINE__);
		}
		elseif(substr($what,0,11)=='tp_dlcatpos'){
			$id=substr($what,11);
			db_query("UPDATE {$tp_prefix}dlmanager SET downloads = $value WHERE id=$id", __FILE__, __LINE__);
		}
		elseif(substr($what,0,18)=='dladmin_screenshot'){
			$id=substr($what,18);
			db_query("UPDATE {$tp_prefix}dlmanager SET screenshot = '$value' WHERE id=$id", __FILE__, __LINE__);
		}
		elseif(substr($what,0,12)=='dladmin_file'){
			$id=substr($what,12);
			db_query("UPDATE {$tp_prefix}dlmanager SET file = '$value' WHERE id=$id", __FILE__, __LINE__);
		}
		// from settings in DLmanager
		elseif($what=='tp_dl_allowed_types'){
			db_query("UPDATE {$tp_prefix}settings SET value = '$value' WHERE name='dl_allowed_types'", __FILE__, __LINE__);
			$go=1;
		}
		elseif($what=='tp_dluploadsize'){
			db_query("UPDATE {$tp_prefix}settings SET value = '$value' WHERE name='dl_max_upload_size'", __FILE__, __LINE__);
			$go=1;
		}
		elseif($what=='tp_dl_approveonly'){
			db_query("UPDATE {$tp_prefix}settings SET value = '$value' WHERE name='dl_approve'", __FILE__, __LINE__);
			$go=1;
		}
		elseif($what=='tp_dlallowupload'){
			db_query("UPDATE {$tp_prefix}settings SET value = '$value' WHERE name='dl_allow_upload'", __FILE__, __LINE__);
			$go=1;
		}
   }
	if($go==1)
	   redirectexit('action=tpmod;dl=adminsettings');
}
	// ****************
	// empty the linktree here
	unset($context['linktree']);
	$context['linktree'] = array();

	// fetch icons, just read the directory
	$context['TPortal']['dlicons'] = array();
	if ($handle = opendir($boarddir.'/tp-downloads/icons')) {
		while (false !== ($file = readdir($handle))) {
			if($file!= '.' && $file!='..' && $file!='.htaccess')
				$context['TPortal']['dlicons'][] = $file;
		}
		closedir($handle);
		sort($context['TPortal']['dlicons']);
	}

   // get all membergroups for permissions
                $context['TPmembergroups'] = array();
                $context['TPmembergroups'][] = array(
                                'id' => '-1',
                                'name' => 'Guests',
                                'posts' => '-1'
                        );
                $context['TPmembergroups'][] = array(
                                'id' => '0',
                                'name' => 'Ungrouped Members',
                                'posts' => '-1'
                        );

                $request = db_query("
                        SELECT * FROM {$db_prefix}membergroups WHERE 1 ORDER BY ID_GROUP", __FILE__, __LINE__);
                while ($row = mysql_fetch_assoc($request))
                {
                        $context['TPmembergroups'][] = array(
                                'id' => $row['ID_GROUP'],
                                'name' => $row['groupName'],
                                'posts' => $row['minPosts']
                        );
                }
				mysql_free_result($request);


	//fetch all categories
	$context['TPortal']['admuploadcats'] = array();
	$context['TPortal']['linkcats'] = array();
	$srequest = db_query("SELECT id, name, description, icon, access, parent FROM {$tp_prefix}dlmanager WHERE type = 'dlcat' ORDER BY downloads ASC", __FILE__, __LINE__);
	if(mysql_num_rows($srequest)>0){
		while ($row = mysql_fetch_assoc($srequest))
		{
			// for the linktree
			$context['TPortal']['linkcats'][$row['id']] = array(
				'id' => $row['id'],
				'name' => $row['name'],
				'parent' => $row['parent'],
				);

			$context['TPortal']['admuploadcats'][] = array(
							'id' => $row['id'],
							'name' => $row['name'],
							'text' => $row['description'],
							'icon' => $row['icon'],
							);
		}
			mysql_free_result($srequest);
	}


	$context['TPortal']['dl_admcats']=array();
	$context['TPortal']['dl_admitems']=array();
	$context['TPortal']['dl_admcount']=array();
	$context['TPortal']['dl_admsubmitted']=array();
	// count items in each category
	$request = db_query("SELECT category FROM {$tp_prefix}dlmanager WHERE type = 'dlitem'", __FILE__, __LINE__);
	if(mysql_num_rows($request)>0){
		while($row=mysql_fetch_assoc($request)){
			if($row['category']<0){
				if(isset($context['TPortal']['dl_admsubmitted'][abs($row['category'])]))
					$context['TPortal']['dl_admsubmitted'][abs($row['category'])]++;
				else
					$context['TPortal']['dl_admsubmitted'][abs($row['category'])]=1;
			}
			else{
				if(isset($context['TPortal']['dl_admcount'][$row['category']]))
					$context['TPortal']['dl_admcount'][$row['category']]++;
				else
					$context['TPortal']['dl_admcount'][$row['category']]=1;
			}
		}
		mysql_free_result($request);
	}


	// fetch all categories
	$admsub = substr($context['TPortal']['dlsub'],5);
	if($admsub==''){
		$context['TPortal']['dl_title'] = 'DL Admin';
		// fetch all categories with subcats
		$req = db_query("SELECT * FROM {$tp_prefix}dlmanager WHERE type = 'dlcat' ORDER BY downloads ASC", __FILE__, __LINE__);
		if(mysql_num_rows($req)>0){
			while($brow=mysql_fetch_assoc($req)){
				if(isset($context['TPortal']['dl_admcount'][$brow['id']]))
					$items=$context['TPortal']['dl_admcount'][$brow['id']];
				else
					$items=0;

				if(isset($context['TPortal']['dl_admsubmitted'][$brow['id']]))
					$sitems=$context['TPortal']['dl_admsubmitted'][$brow['id']];
				else
					$sitems=0;

				$context['TPortal']['admcats'][] = array(
					'id' => $brow['id'],
					'name' => $brow['name'],
					'icon' => $brow['icon'],
					'access' => $brow['access'],
					'parent' => $brow['parent'],
					'description' => $brow['description'],
					'items' => $items,
					'submitted' => $sitems,
					'total' => ($items + $sitems),
					'href' => $scripturl.'?action=tpmod;dl=admincat'.$brow['id'],
					'href2' => $scripturl.'?action=tpmod;dl=admineditcat'.$brow['id'],
					'href3' => $scripturl.'?action=tpmod;dl=admindelcat'.$brow['id'],
					'pos' => $brow['downloads'],
					);
			}
			mysql_free_result($req);
		}
	}
	elseif(substr($admsub,0,3)=='cat'){
		$cat=substr($admsub,3);
		// get the parent first
		$request = db_query("SELECT parent,name FROM {$tp_prefix}dlmanager WHERE type = 'dlcat' AND id=$cat", __FILE__, __LINE__);
		if(mysql_num_rows($request)>0){
			$row=mysql_fetch_assoc($request);
			$catparent=$row['parent'];
			$catname=$row['name'];
			mysql_free_result($request);
		}

		// fetch items within a category
		$request = db_query("SELECT dl.*, m.realName
						FROM {$tp_prefix}dlmanager AS dl, {$db_prefix}members AS m
						WHERE abs(dl.category)=$cat
						AND dl.type = 'dlitem'
						AND dl.authorID = m.ID_MEMBER
						ORDER BY dl.id DESC", __FILE__, __LINE__);
		if(mysql_num_rows($request)>0){
			while($row=mysql_fetch_assoc($request)){
				$context['TPortal']['admitems'][] = array(
					'id' => $row['id'],
					'name' => $row['name'],
					'icon' => $row['icon'],
					'category' => abs($row['category']),
					'file' => $row['file'],
					'filesize' => floor($row['filesize']/1024),
					'views' => $row['views'],
					'authorID' => $row['authorID'],
					'author' => '<a href="'.$scripturl.'?action=profile;u='.$row['authorID'].'">'.$row['realName'].'</a>',
					'created' => timeformat($row['created']),
					'last_access' => timeformat($row['last_access']),
					'description' => $row['description'],
					'downloads' => $row['downloads'],
					'sshot' => $row['screenshot'],
					'link' => $row['link'],
					'href' => $scripturl.'?action=tpmod;dl=adminitem'.$row['id'],
					'approved' => $row['category']<0 ? '0' : '1',
					'approve' => $scripturl.'?action=tpmod;dl=adminapprove'.$row['id'],
				);
			}
			mysql_free_result($request);
		}
		// fetch all categories with subcats
		$request = db_query("SELECT * FROM {$tp_prefix}dlmanager WHERE type = 'dlcat' ORDER BY name ASC", __FILE__, __LINE__);
		if(mysql_num_rows($request)>0){
			while($row=mysql_fetch_assoc($request)){
				if(isset($context['TPortal']['dl_admcount'][$row['id']]))
					$items=$context['TPortal']['dl_admcount'][$row['id']];
				else
					$items=0;

				if(isset($context['TPortal']['dl_admsubmitted'][$row['id']]))
					$sitems=$context['TPortal']['dl_admsubmitted'][$row['id']];
				else
					$sitems=0;

				$context['TPortal']['admcats'][] = array(
					'id' => $row['id'],
					'name' => $row['name'],
					'icon' => $row['icon'],
					'access' => $row['access'],
					'parent' => $row['parent'],
					'description' => $row['description'],
					'items' => $items,
					'submitted' => $sitems,
					'total' => ($items + $sitems),
					'href' => $scripturl.'?action=tpmod;dl=admincat'.$row['id'],
					'href2' => $scripturl.'?action=tpmod;dl=admineditcat'.$row['id'],
					'href3' => $scripturl.'?action=tpmod;dl=admindelcat'.$row['id'],
					);
			}
			mysql_free_result($request);
		}
		// check to see if its child
		$parents=array();
		while($catparent>0 ){
			$parents[$catparent] = array(
				'id' => $catparent,
				'name' => $context['TPortal']['linkcats'][$catparent]['name'],
				'parent' => $context['TPortal']['linkcats'][$catparent]['parent']
				);
			$catparent = $context['TPortal']['linkcats'][$catparent]['parent'];
		}

		// make the linktree
		TPadd_linktree($scripturl.'?action=tpmod;dl=admin', 'DL admin');

		if(isset($parents)){
			$parts=array_reverse($parents,TRUE);
			// add to the linktree
			foreach($parts as $parent){
				TPadd_linktree($scripturl.'?action=tpmod;dl=admincat'.$parent['id'] , $parent['name']);
			}
		}
		// add to the linktree
		TPadd_linktree($scripturl.'?action=tpmod;dl=admincat'.$cat , $catname);
	}
	elseif($context['TPortal']['dlsub']=='adminsubmission'){
			// check any submissions if admin
			$submitted=array();
			isAllowedTo('tp_dlmanager');
			$context['TPortal']['admitems'] = array();
			$request = db_query("SELECT dl.id, dl.name, dl.file, dl.created, dl.filesize, dl.authorID, m.realName
						FROM {$tp_prefix}dlmanager AS dl, {$db_prefix}members AS m
						WHERE dl.type = 'dlitem'
						AND dl.category<0
						AND dl.authorID = m.ID_MEMBER", __FILE__, __LINE__);
			if(mysql_num_rows($request)>0)
			{
				$rows=mysql_num_rows($request);
				while ($row = mysql_fetch_assoc($request))
				{
					$context['TPortal']['admitems'][] = array(
						'id' => $row['id'],
						'name' => $row['name'],
						'file' => $row['file'],
						'href' => $scripturl.'?action=tpmod;dl=adminitem'.$row['id'],
						'author' => '<a href="'.$scripturl.'?action=profile;u='.$row['authorID'].'">'.$row['realName'].'</a>',
						'date' => timeformat($row['created']),
						);
						$submitted[]=$row['id'];
				}
				mysql_free_result($request);
			}
			// check that submissions link to downloads
			$request = db_query("SELECT id,value5 FROM {$tp_prefix}variables WHERE type='dl_not_approved'", __FILE__, __LINE__);
			if(mysql_num_rows($request)>0){
				while($row=mysql_fetch_assoc($request)){
					$what=$row['id'];
					if(!in_array($row['value5'],$submitted))
						db_query("DELETE FROM {$tp_prefix}variables WHERE id=$what", __FILE__, __LINE__);
				}
				mysql_free_result($request);
			}
	}
	elseif(substr($admsub,0,7)=='editcat'){
		$context['TPortal']['dl_title'] = '<a href="'.$scripturl.'?action=tpmod;dl=admin">DL Admin</a>';
		$cat=substr($admsub,7);
		// edit category
		$request = db_query("SELECT * FROM {$tp_prefix}dlmanager WHERE id=$cat AND type = 'dlcat' LIMIT 1", __FILE__, __LINE__);
		if(mysql_num_rows($request)>0){
			while($row=mysql_fetch_assoc($request)){
				$context['TPortal']['admcats'][] = array(
					'id' => $row['id'],
					'name' => $row['name'],
					'access' => $row['access'],
					'description' => $row['description'],
					'icon' => $row['icon'],
					'parent' => $row['parent'],
				);
			}
			mysql_free_result($request);
		}
	}
	elseif(substr($admsub,0,6)=='delcat'){
		$context['TPortal']['dl_title'] = '<a href="'.$scripturl.'?action=tpmod;dl=admin">DL Admin</a>';
		$cat=substr($admsub,6);
		// delete category and all item it's in
		$request = db_query("DELETE FROM {$tp_prefix}dlmanager WHERE type='dlitem' AND category = $cat", __FILE__, __LINE__);
		$request = db_query("DELETE FROM {$tp_prefix}dlmanager WHERE id=$cat LIMIT 1", __FILE__, __LINE__);
		redirectexit('action=tpmod;dl=admin');
	}
	elseif(substr($admsub,0,8)=='settings'){
		$context['TPortal']['dl_title'] = $txt['tp-dlsettings'];
	}
	elseif(substr($admsub,0,4)=='item'){
		$item=substr($admsub,4);
		$request = db_query("SELECT * FROM {$tp_prefix}dlmanager WHERE id=$item AND type = 'dlitem' LIMIT 1", __FILE__, __LINE__);
		if(mysql_num_rows($request)>0){
			while($row=mysql_fetch_assoc($request)){
				$context['TPortal']['admitems'][] = array(
					'id' => $row['id'],
					'name' => $row['name'],
					'icon' => $row['icon'],
					'category' => $row['category'],
					'file' => $row['file'],
					'views' => $row['views'],
					'authorID' => $row['authorID'],
					'description' => $row['description'],
					'created' => timeformat($row['created']),
					'last_access' => timeformat($row['last_access']),
					'filesize' => floor($row['filesize']/1024),
					'downloads' => $row['downloads'],
					'sshot' => $row['screenshot'],
					'link' => $row['link'],
					'href' => $scripturl.'?action=tpmod;dl=adminitem'.$row['id'],
					'approved' => $row['category'] < 0 ? '0' : '1' ,
					'approve' => $scripturl.'?action=tpmod;dl=adminitem'.$row['id'],
					);
				$authorID=$row['authorID'];
				$catparent=$row['category'];
				$itemname=$row['name'];
			}
			mysql_free_result($request);
			$request = db_query("SELECT realName FROM {$db_prefix}members WHERE ID_MEMBER=$authorID LIMIT 1", __FILE__, __LINE__);
			if(mysql_num_rows($request)>0){
				$row=mysql_fetch_assoc($request);
				$context['TPortal']['admcurrent']['member']=$row['realName'];
				mysql_free_result($request);
			}
			else
				$context['TPortal']['admcurrent']['member']='-guest-';
		}
		// check to see if its child
		$parents=array();
		while($catparent>0 ){
			$parents[$catparent] = array(
				'id' => $catparent,
				'name' => $context['TPortal']['linkcats'][$catparent]['name'],
				'parent' => $context['TPortal']['linkcats'][$catparent]['parent']
				);
			$catparent = $context['TPortal']['linkcats'][$catparent]['parent'];
		}

		// make the linktree
		TPadd_linktree($scripturl.'?action=tpmod;dl=admin', $txt['tp-dldownloads']);

		if(isset($parents)){
			$parts=array_reverse($parents,TRUE);
			// add to the linktree
			foreach($parts as $parent){
				TPadd_linktree($scripturl.'?action=tpmod;dl=admincat'.$parent['id'] , $parent['name']);
			}
		}
		// add to the linktree
		TPadd_linktree($scripturl.'?action=tpmod;dl=adminitem'.$item , $itemname);
	}
	$context['html_headers'] .= '<script language="JavaScript" type="text/javascript" src="'. $boardurl. '/wysiwyg/whizzywig.js"></script>';
	loadtemplate('TPdladmin');
	adminIndex('tportal');

		// setup admin tabs according to subaction
			$context['admin_tabs'] = array(
				'title' => $txt['tp-dlheader1'],
				'help' => $txt['tp-dlheader2'],
				'description' => $txt['tp-dlheader3'],
				'tabs' => array(),
				);
			if (allowedTo('tp_dlmanager'))
			{
				$context['admin_tabs']['tabs'] = array(
					'admin' => array(
					'title' => $txt['tp-dltabs4'],
					'description' => '',
					'href' => $scripturl . '?action=tpmod;dl=admin',
					'is_selected' => substr($context['TPortal']['dlsub'],0,5)=='admin' && $context['TPortal']['dlsub']!='adminsettings' && $context['TPortal']['dlsub']!='adminaddcat',
					),
					'settings' => array(
					'title' => $txt['tp-dltabs1'],
					'description' => '',
					'href' => $scripturl . '?action=tpmod;dl=adminsettings',
					'is_selected' => $context['TPortal']['dlsub']=='adminsettings',
					),
					'addcategory' => array(
					'title' => $txt['tp-dltabs2'],
					'description' => '',
					'href' => $scripturl . '?action=tpmod;dl=adminaddcat',
					'is_selected' => $context['TPortal']['dlsub']=='adminaddcat',
					),
					'upload' => array(
					'title' => $txt['tp-dltabs3'],
					'description' => '',
					'href' => $scripturl . '?action=tpmod;dl=upload',
					'is_selected' => $context['TPortal']['dlsub'] == 'upload',
					),
					'submissions' => array(
					'title' => $txt['tp-dlsubmissions'].' ' , $context['TPortal']['submitcheck']['uploads']>0 ? '('.$context['TPortal']['submitcheck']['uploads'].')' : '' ,
					'description' => '',
					'href' => $scripturl . '?action=tpmod;dl=adminsubmission',
					'is_selected' => $context['TPortal']['dlsub'] == 'adminsubmission',
					),
				);
			}
}

function dlsort($a, $b) {
	   return strnatcasecmp($b["items"], $a["items"]);
}
function dlsortviews($a, $b) {
	   return strnatcasecmp($b["views"], $a["views"]);
}
function dlsortsize($a, $b) {
	   return strnatcasecmp($b["size"], $a["size"]);
}
function dlsortdownloads($a, $b) {
	   return strnatcasecmp($b["downloads"], $a["downloads"]);
}


?>